SystemOrganization addCategory: #CSV!

Object subclass: #CSVParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSV'!

!CSVParser class methodsFor: 'as yet unclassified' stamp: 'avi 7/4/2005 21:43'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!CSVParser class methodsFor: 'as yet unclassified' stamp: 'avi 7/4/2005 22:08'!
parse: aStream
	^ (self on: aStream) rows! !

!CSVParser class methodsFor: 'as yet unclassified' stamp: 'avi 7/4/2005 22:08'!
parseString: aString
	^ self parse: aString readStream! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 6/14/2011 07:11'!
atEndOfLine
	^ ((stream atEnd or: [stream peek = Character cr]) or: [stream peek = Character lf])! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:39'!
initializeWithStream: aStream
	stream := aStream! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:39'!
nextInLine
	| next |
	next := stream next.
	(next = Character cr or: [next = Character lf])
		ifTrue:	[stream skip: -1. next := nil].
	^ next! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'avi 9/19/2005 23:48'!
nextQuotedValue
	^ String streamContents:
		[:s |
		s nextPutAll: (stream upTo: $").
		self nextInLine = $" ifTrue:
			[s nextPut: $".
			s nextPutAll: self nextQuotedValue]]! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:39'!
nextRow
	| row |
	row := OrderedCollection new.
	stream skipSeparators.
	[self atEndOfLine]
		whileFalse: [row add: self nextValue].
	stream skip: -1.
	stream next = $, ifTrue: [row add: ''].
	^ row! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:40'!
nextValue
	| next |
	stream peek = $" ifTrue: [stream next. ^ self nextQuotedValue].
	^ String streamContents:
		[:s |
		[(next := self nextInLine) notNil and: [next ~= $,]]
			whileTrue: [s nextPut: next]]! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'avi 7/4/2005 22:08'!
rows
	^ Array streamContents: [:s | self rowsDo: [:ea | s nextPut: ea]]! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:40'!
rowsDo: aBlock
	| row |
	[stream atEnd] whileFalse:
		[row := self nextRow.
		row isEmpty ifFalse: [aBlock value: row]]! !

!CSVParser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/3/2010 15:56'!
test
^CSVParser parse: ((FileStream oldFileNamed: '/Users/stephan/Documents/Sensus/Klanten/VBridge/bureaugegevens20100802.csv') converter: (TextConverter default);yourself)! !
